package com.candidjava.hibernate;

import org.hibernate.HibernateException;
import org.hibernate.ScrollableResults;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;

public class EmpBatchDao {

	private static SessionFactory factory;

	public Session getSession() {
		Session session = null;
		try {
			factory = new Configuration().configure().buildSessionFactory();
			session = factory.openSession();
		} catch (Throwable ex) {
			System.err.println("Failed to create sessionFactory object." + ex);
			throw new ExceptionInInitializerError(ex);
		}
		return session;
	}

	public void addEmployees() {
		Session s = getSession();
		Transaction tx = null;
		try {
			tx = s.beginTransaction();
			for (int i = 10; i < 200; i++) {
				String fname = "candidjava " + i;
				Integer age = i + 10;
				String city = "City " + i;
				Integer salary = i + 1000;
				String gender;
				if (i % 2 == 0) {
					gender = "Male";
				} else {
					gender = "Female";
				}
				Employee employee = new Employee(fname, age, salary, city,
						gender);
				s.save(employee);
				if (i % 20 == 0) {
					s.flush();
					s.clear();
				}
			}
			tx.commit();
		} catch (HibernateException e) {
			if (tx != null)
				tx.rollback();
			e.printStackTrace();
		} finally {
			s.close();
		}
		return;
	}

	public void updateEmployees() {
		Session s = getSession();
		Transaction tx = null;
		try {
			tx = s.beginTransaction();
			ScrollableResults empCursor = s.createQuery("FROM Employee")
					.scroll();
			int count = 0;
			while (empCursor.next()) {
				Employee employ = (Employee) empCursor.get(0);
				employ.setName("Naty");
				s.update(employ);
				if (++count % 20 == 0) {
					s.flush();
					s.clear();
				}
			}
			tx.commit();
		} catch (HibernateException e) {
			if (tx != null)
				tx.rollback();
			e.printStackTrace();
		} finally {
			s.close();
		}
	}
}
